<template>
  <div id="app">
 <main>
   <div class="search-box">
       <input
           type="text"
           class="search-bar"
           placeholder="Recherche..."
           v-model="query"
           @keypress="fetchWeather"
       >

   </div>

   <div class="weather-wrap" v-if="typeof weather.main != 'undefined'">
     <div class="location-box">
       <div class="location">{{weather.name}}, {{weather.sys.country}}</div>
       <div class="date">{{ dateBuilder () }}</div>
     </div>

     <div class="weather-box">
       <div class="temp">Actual temperature {{Math.round(weather.main.temp) }}°c</div>
       <div class="temp">Feels like {{Math.round(weather.main.feels_like) }}°c</div>
       <div class="temp">Min {{Math.round(weather.main.temp_min) }}°c</div>
       <div class="temp">Max {{Math.round(weather.main.temp_max)}}°c</div>

       <div class="weather">{{ weather.weather[0].main}}
         <img :src="'http://openweathermap.org/img/wn/'+weather.weather[0].icon+'@2x.png'">
        </div>

       <div class="temp">
          <div class="location temp">Sunrise {{timestampToDate(weather.sys.sunrise)}}</div>
          <div class="location temp">Sunset {{timestampToDate(weather.sys.sunset)}}</div>
       </div>

       <div class="temp">
         <div class="location">Wind speed {{Math.round(weather.wind.speed)}} m/s</div>
         <div class="location">Wind {{degreesToCompass(weather.wind.deg)}}</div>
       </div>

       <div class="temp">
          <div class="location">Latitude {{weather.coord.lat}}</div>
           <div class="location">Longitude {{weather.coord.lon}}</div>
       </div>

     </div>

   </div>
 </main>
  </div>
</template>

<script>

export default {
  name: 'App',
  data (){
    return {
      api_kye: '62056875c74c0aebda396646c8b50671',
      url_base: 'https://api.openweathermap.org/data/2.5/',
      query: '',
      weather: {},
      lon: '',
      lat: '',
    }
  },
  methods: {
    fetchWeather (e) {
      if (e.key === "Enter") {
        fetch(`${this.url_base}weather?q=${this.query}&units=metric&APPID=${this.api_kye}`)
          .then(res => {
            return res.json();
          }).then(this.setResults);
      }
    },
    setResults (results) {
      this.weather = results;
      this.query = results.name;
    },

    fetchGeo(){
        fetch(`${this.url_base}weather?lat=${this.lat}&lon=${this.lon}&appid=${this.api_kye}`)
      .then(res => {
        return res.json();
      }).then(this.setResults)
    },

    dateBuilder () {
      let d = new Date();
      let months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
      let days = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
      let day = days[d.getDay()];
      let date = d.getDate();
      let month = months[d.getMonth()];
      let year = d.getFullYear();
      return `${day} ${date} ${month} ${year}`;
    },

    //sunset et surise methode
    timestampToDate: function (timestamp)
    {
      let date = new Date(timestamp*1000);
      return date.toString();
    },

      //wind
    degreesToCompass: function(deg)
    {
      let val = Math.floor((deg / 22.5) + 0.5);
      let dir = ["N","NNE","NE","ENE","E","ESE", "SE", "SSE","S","SSW","SW","WSW","W","WNW","NW","NNW"];

      return dir[(val % 16)];
    },

  },
  //cicle de vie pour geolocalisation
  created () {
    navigator.geolocation.getCurrentPosition((position) => {
      this.lat = position.coords.latitude;
      this.lon = position.coords.longitude;

      this.fetchGeo();
    });
  }
}

</script>

<style>
* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}

body {
  font-family: "Helvetica";
}

#app {
  background-image: url("./assets/thunderstorm.jpg");
  background-size: cover;
  background-position: bottom;
  transition: 0.4s;
}

main {
  min-height: 100vh;
  padding: 25px;

  background-image: linear-gradient(to bottom, rgba(0,0,0,0.25), rgba(0, 0, 0, 0.75));
}

.search-box {
  width: 100%;
  margin-bottom: 30px;
}

.search-box .search-bar {
  display: block;
  width: 100%;
  padding: 15px;

  color: #313131;
  font-size: 20px;

  appearance: none;
  border: none;
  outline: none;
  background: none;

  box-shadow: 0px 0px 8px rgba(0, 0, 0, 0.25);
  background-color: rgba(255, 255, 255,0.5);
  border-radius: 0px 16px 0px 16px;
  transition: 0.4s;
}

.search-box .search-bar:focus {
  box-shadow: 0px 0px 16px rgba(0, 0, 0, 0.25);
  background-color: rgba(255, 255, 255, 0.75);
  border-radius: 16px 0px 16px 0px;
}

.location-box .location {
  color: #FFF;
  font-size: 32px;
  font-weight: 500;
  text-align: center;
  text-shadow: 1px 3px rgba(0, 0, 0, 0.25);
}

.location-box .date {
  color: #FFF;
  font-size: 20px;
  font-weight: 300;
  font-style: italic;
  text-align: center;
}

.weather-box {
  text-align: center;
}

.weather-box .temp {
  display: inline-block;
  padding: 10px 25px;
  color: #FFFFFF;
  font-size: 50px;
  font-weight: 450;
  text-shadow: 3px 6px rgba(0, 0, 0, 0.25);
  background-color: rgba(255, 255, 255, 0.25);
  border-radius: 8px;
  margin: 15px;

  box-shadow: 3px 6px rgba(0, 0, 0, 0.25);
}

.weather-box .weather {
  color: #FFFFFF;
  font-size: 48px;
  font-weight: 700;
  font-style: italic;
  text-shadow: 3px 6px rgba(0, 0, 0, 0.25);
}

</style>
